<%@ Page Language="VB" %>
<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="ReadyPOP3" %>
<%@ Import Namespace="System.IO" %>
<link href="styles.css" rel="stylesheet" type="text/css">
<%
ID = request.querystring("ID")

DISPLAYHTML = request.querystring("HTML")
If DISPLAYHTML = "" then
	DISPLAYHTML = False
End If

Main()
%>
<script language="vb" runat="server">


Const SHOWHEADERSONLY = False

Dim PlainBody,HTMLBody as String
Dim IsHTML as Boolean
Dim ATTACHStr as String
Dim ATTACHArray as Array
Dim DISPLAYHTML as String



Sub Main()
    Dim POP3HOST,POP3USER,POP3PASS
	POP3HOST = Session("POP3HOST")
	POP3USER = Session("POP3USER")
	POP3PASS = Session("POP3PASS")
    
    ' connect to POP3 server
    Dim pop3 As New POP3Client
    pop3.Serial = Session("SERIAL")
    
    pop3.Host = POP3HOST
    pop3.Username = POP3USER
    pop3.Password = POP3PASS
    Try
		pop3.Connect()
	Catch
		Response.write("Error connecting to POP3 server.<br>")
		Exit Sub	
	End Try
    If pop3.ServerState = POP3ServerState.Disconnected Then
        Response.write("Couldn't connect to POP3 server.<BR>")
        Exit Sub
    End If
    If pop3.ServerState <> POP3ServerState.Transaction Then
        Response.write("Couldn't login to POP3 server, bad username or password.<BR>")
        Exit Sub
    End If

    ' retrieve and display message

	Dim message as String
	If SHOWHEADERSONLY Then
		message = pop3.Top(ID)
	Else
		message = pop3.Retr(ID)
	End If
	
    If Not message.StartsWith("-ERR") Then
		Dim msg As New ReadyPOP3.Message(message)
		
		' get and display ReadyPOP3 headers
		
		Dim sClip,sSubject,sFrom,sDate,sTo,sCc,sMID,sBody as String
		
		sClip = ""
		sSubject = ""
		sFrom = ""
		sDate = ""
		sTo = ""
		sCc = ""
		sMID = ""
		sBody = ""
		
		sSubject = msg.Subject
		sFrom = msg.From
		sDate = msg.DateSent
		sTo = msg.SentTo
		sCc = msg.Cc
		sMID = msg.MessageID

		If msg.HasAttachments = True then
			sClip = "<img src=""./images/clip.gif"">"
		Else
			sClip = ""
		End If
		
		If msg.HtmlBody <> "" and DISPLAYHTML = True then
			sBody = msg.HtmlBody
			If InStr(1,sBody,"/style>") <> 0 and InStr(1,sBody,"</style>") = 0 then
				sBody = Replace(sBody,"/style>","</style>")
			End If
			'sBody = Replace(UCase(sBody),"<HTML>","")
			'sBody = Replace(UCase(sBody),"</HTML>","")
			'sBody = Replace(UCase(sBody),"<BODY>","")
			'sBody = Replace(UCase(sBody),"</BODY>","")
			'dim HSPOS,HEPOS
			'HSPOS = Instr(1,UCase(sBody),"<HEAD>")
			'HEPOS = Instr(1,UCase(sBody),"</HEAD>") + 7
			'sBody = Replace(sBody,Mid(sBody,HSPOS,HEPOS-HSPOS),"")
		Else
			sBody = "<pre class=""norm"">" & Server.HTMLEncode(msg.PlainBody) & "</pre>"
		End If
		
		Response.write("<div class=""norm"" style=""border: 1px solid black; padding: 4px"" align=""left"">")
		Response.write("<b>Subject:</b> " & sSubject & "<BR>")
		Response.write("<b>From:</b> " & sFrom & "<BR>")
		Response.write("<b>Date:</b> " & sDate & "<BR>")
		Response.write("<b>To:</b> " & sTo & "<BR>")
		If sCc <> "" then
			Response.write("Cc: " & sCc & "<BR>")
		End If
		response.write("</div>")

		' print blank line between header and msg data
		'Response.write("<BR>")
		If DISPLAYHTML = False then
			response.write("<div align=""center"" class=""head""><a href=""./message.aspx?ID=" & ID & "&HTML=True"">View as HTML</a></div>")
		Else
			response.write("<div align=""center"" class=""head""><a href=""./message.aspx?ID=" & ID & "&HTML=False"">View as Plain Text</a></div>")
		End If
		' display the message content
		response.write("<div style=""border: 1px solid black; padding: 4px"" align=""left"">" & sBody & "</div>")

		If msg.HasAttachments = True then
			response.write("<br>")
			response.write("<div class=""head""><img src=""./images/clip.gif"">&nbsp;<u>Attachments</u></div>")
			Dim i
			For i = 0 to msg.Attachments.count-1
				msg.Attachments(i).SaveAs(Server.Mappath("./attachments/") & "\" & msg.Attachments(i).name)
				response.write("<div>&nbsp;&nbsp;&nbsp;&nbsp;<a href=""./attachments/" & msg.Attachments(i).name & """ target=""_blank"" class=""norm"">" & msg.Attachments(i).name & "</div>")
			Next
		End If
		
	Else
		Response.write("<br><hr>Unable to retrieve message #" & ID & "<br>")
	End If
    ' disconnect from POP3 server		
    pop3.Quit()
    pop3.Disconnect()

End Sub
</script>
